<template lang="pug">

.dropdown
  button#dropdownImportExport.btn.btn-sm.btn-outline-secondary.dropdown-toggle(type='button'
    data-toggle='dropdown' aria-haspopup='true' aria-expanded='false')
    | Import / Export
    .dropdown-menu(aria-labelledby='dropdownImportExport')
      a.dropdown-item(href='#' @click='openImportDialog()') Import JSON / CSV
      .dropdown-divider
      a.dropdown-item(href='#' @click='exportJSON()') Export JSON
      a.dropdown-item(href='#' @click='exportCSV()') Export CSV

  BaseDialog.x-modal-import(ref='importDialog' title='Import Daq Configuration')
    // File Info
    .p-5(v-if='confFile')
      div #[strong FileName]: {{ confFile.name }}
      div #[strong Modified Date]: {{ confFile.lastModified | b-moment("yyyy-MM-dd HH:mm:ss ZZ") }}
      // Warnings / OK checks
      div(v-if="$butils.isEmpty(warnings)")
        .alert.alert-success(role='alert')
          i.fas.fa-check.mr-2
          span Sanity Checks: OK
      div(v-else)
        .alert.alert-warning(role='alert')
          i.fa.fa-exclamation.mr-2
          span Sanity Checks: Warnings
          hr
          ul
            li(v-for="(msg, daq) in warnings") #[strong {{ daq }}]: {{ msg }}
      // Actions
      div.mt-2.float-right
        button.x-cancel.btn.btn-sm.btn-secondary.mx-1(type='submit' @click='remove()')
          i.fas.fa-trash.mr-2
          span Cancel
        button.x-apply.btn.btn-sm.btn-primary.mx-1(type='submit' @click='applyConf()'
            v-if="!$butils.isEmpty(configuration)")
          .spinner-border.spinner-border-sm.text-light.mr-2(v-if='isConfiguring')
          i(v-else).fas.fa-check.mr-2
          span Apply Configuration

    // Drop Area
    .p-5.border(v-else :class="{ 'border-primary x-bg-highlight': dragOver, 'border-secondary': !dragOver }"
                @dragover='dragover' @dragleave='dragleave' @drop='drop')
      .text-center
        input.d-none(ref='fileInput' type='file' id='assetsFieldHandle' name='dropFile' @change='onChange'  accept='.json,.csv')
        label.m-0.p-0(for='assetsFieldHandle')
          div.mt-2.align-middle
            | Drag & Drop here your configuration file or #[u click here] to upload it.
    // Footer
    template(v-slot:footer='d')
      button.btn.btn-secondary(@click='d.resolve(true)') Close
</template>

<script>

export { default } from './ImportExportDropDownTools.vue.js';

</script>

<style lang='scss'>
.x-modal-import .modal-content {
    height: auto !important;
}

.x-bg-highlight {
  background-color: lightblue;
}
</style>
